package com.syjy.calculate.function;

import com.googlecode.aviator.AviatorEvaluator;
import com.googlecode.aviator.runtime.RuntimeUtils;
import com.googlecode.aviator.runtime.function.AbstractFunction;
import com.googlecode.aviator.runtime.type.AviatorDecimal;
import com.googlecode.aviator.runtime.type.AviatorObject;
import com.googlecode.aviator.runtime.type.Sequence;

import java.math.BigDecimal;
import java.util.HashMap;
import java.util.Map;

/**
 * 计算准确率 :均方根准确率绝对值
 *
 * @author zcl
 * @version 1.0
 * @since 2022/9/8 9:30
 */
public class RootMeanSquaredErrorS extends AbstractFunction {
    @Override
    public AviatorObject call(Map<String, Object> env, AviatorObject arg1) {
        // 获取参数
        Object first = arg1.getValue(env);
        // 获取Σ(sj-yc)²
        BigDecimal sumDifferenceSquare = new BigDecimal(String.valueOf(AviatorEvaluator.execute("sumDifferenceSquare(list)",env)));
        Map<String, Object> map = new HashMap<>();
        map.put("sumDifferenceSquare",sumDifferenceSquare);
        map.put("rl",env.get("rl"));
        // 将参数转为集合
        Sequence seq = RuntimeUtils.seq(first, env);
        BigDecimal size = new BigDecimal(seq.hintSize());
        map.put("size",size);
        BigDecimal result = (BigDecimal) AviatorEvaluator.execute("math.sqrt(sumDifferenceSquare)/(rl*math.sqrt(size))",map);
        return new AviatorDecimal(result);
    }
    @Override
    public String getName() {
        return "rootMeanSquaredErrorS";
    }
}
